// HtmlEditorDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "HtmlEditorDlg.h"
#include "NeMessengerDlg.h"

// CHtmlEditorDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CHtmlEditorDlg, CDialog)

CHtmlEditorDlg::CHtmlEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHtmlEditorDlg::IDD, pParent)
{

}

CHtmlEditorDlg::~CHtmlEditorDlg()
{
}

void CHtmlEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HTML_EDITOR, m_stEditor);
	DDX_Control(pDX, IDC_FONT_COMBO, m_cmbFont);
	DDX_Control(pDX, IDC_FONT_SIZE_COMBO, m_cmbFontSize);
	DDX_Control(pDX, IDC_BOLD_BUTTON, m_btnBold);
	DDX_Control(pDX, IDC_UNDERLINE_BUTTON, m_btnUnderLine);
	DDX_Control(pDX, IDC_ITALIC_BUTTON, m_btnItalic);
	DDX_Control(pDX, IDC_FONT_COLOR_BUTTON, m_btnFontColor);
	DDX_Control(pDX, IDC_EDIT1, m_edHtml);
}


BEGIN_MESSAGE_MAP(CHtmlEditorDlg, CDialog)
	ON_BN_CLICKED(IDC_GET_HTML_BUTTON, &CHtmlEditorDlg::OnBnClickedGetHtmlButton)
	ON_BN_CLICKED(IDC_SET_HTML_BUTTON, &CHtmlEditorDlg::OnBnClickedSetHtmlButton)
	ON_BN_CLICKED(IDC_BOLD_BUTTON, &CHtmlEditorDlg::OnBnClickedBoldButton)
	ON_BN_CLICKED(IDC_UNDERLINE_BUTTON, &CHtmlEditorDlg::OnBnClickedUnderlineButton)
	ON_CBN_SELCHANGE(IDC_FONT_COMBO, &CHtmlEditorDlg::OnCbnSelchangeFontCombo)
	ON_CBN_SELCHANGE(IDC_FONT_SIZE_COMBO, &CHtmlEditorDlg::OnCbnSelchangeFontSizeCombo)
	ON_BN_CLICKED(IDC_FONT_COLOR_BUTTON, &CHtmlEditorDlg::OnBnClickedFontColorButton)
	ON_BN_CLICKED(IDC_ITALIC_BUTTON, &CHtmlEditorDlg::OnBnClickedItalicButton)
END_MESSAGE_MAP()


INT CALLBACK NEnumFontNameProc(LOGFONT *plf, TEXTMETRIC* /*ptm*/, INT /*nFontType*/, LPARAM lParam)
{
	CComboBox* comboBox = (CComboBox*) lParam;
	comboBox->AddString(plf->lfFaceName);
	return TRUE;
}
UINT_PTR CALLBACK CFontHook(  HWND hdlg,UINT uiMsg,WPARAM /*wParam*/, LPARAM lParam)
{
	if(uiMsg == WM_INITDIALOG)
	{
		CHOOSECOLOR *pcc = (CHOOSECOLOR*)lParam;
		CRect *rc = (CRect*)pcc->lCustData;
		if(rc)
			SetWindowPos(hdlg,HWND_TOP,rc->right,rc->bottom,
			0,0,SWP_NOZORDER|SWP_NOSIZE);
		CString str;
		str.LoadString(IDS_STRING168);
		SetWindowText(hdlg,str);
		delete rc;
	}
	return 0;
}



// CHtmlEditorDlg ޽ óԴϴ.

BOOL CHtmlEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	CRect rcStatic(0, 0, 0, 0);
	rcStatic.SetRect(0, 100, 300, 600);
	m_htmlEditor.Create(L"htmlEitor",(WS_CHILD |WS_VISIBLE) , rcStatic, this,IDC_HTML_EDITOR,0 );

	
	m_htmlEditor.SetDesignMode(TRUE);
	InitFontSize();
	
	HDC hdc = ::GetDC(this->m_hWnd);
	::EnumFontFamilies(hdc, NULL, (FONTENUMPROC)NEnumFontNameProc, (LPARAM)&m_cmbFont);

	int nSel;
	short nSize = 0;

	CString strFontName;
	ASSERT_VALID(&m_cmbFont);

	//̻ϰ Ʈ  ´..Ʈ   µ..
	//Ƹ ý Ʈ   GetFont ؼ ׷.
	m_htmlEditor.GetFontFace(strFontName);
	nSel = m_cmbFont.FindString(-1,strFontName);
	if(nSel != CB_ERR)
		m_cmbFont.SetCurSel(nSel);

	CString strFontSize;
	ASSERT_VALID(&m_cmbFontSize);
	m_htmlEditor.GetFontSize(nSize);
	CString strFindFontSize;
	strFindFontSize.Format(L"%d",nSize);
	nSel = m_cmbFontSize.FindString(-1,strFindFontSize);
	if(nSel != CB_ERR)
		m_cmbFontSize.SetCurSel(nSel);

	::ReleaseDC(this->m_hWnd, hdc);

	return TRUE;  // return TRUE unless you set the focus to a 
}

void CHtmlEditorDlg::OnBnClickedGetHtmlButton()
{
	CString strHtml;
	GetHtmlDocument(strHtml);
	m_edHtml.SetWindowText(strHtml);
}

void CHtmlEditorDlg::OnBnClickedSetHtmlButton()
{
	CString strHtml;
	m_edHtml.GetWindowText(strHtml);
	SetHtmlDocument(strHtml);
}

HRESULT CHtmlEditorDlg::GetHtmlDocument( CString& strHtml )
{
	HRESULT hr = m_htmlEditor.GetDocumentHTML(strHtml);
	return hr;
}

HRESULT CHtmlEditorDlg::SetHtmlDocument( CString strHtml )
{
	HRESULT hr =m_htmlEditor.SetDocumentHTML(strHtml);
	return hr;
}

void CHtmlEditorDlg::OnBnClickedBoldButton()
{
	m_htmlEditor.Bold();
}

void CHtmlEditorDlg::OnBnClickedUnderlineButton()
{
	m_htmlEditor.Underline();
}



void CHtmlEditorDlg::OnCbnSelchangeFontCombo()
{
	CString strFontName;
	m_cmbFont.GetLBText(m_cmbFont.GetCurSel(),strFontName);
	m_htmlEditor.SetFontFace(strFontName);
}

void CHtmlEditorDlg::OnCbnSelchangeFontSizeCombo()
{
	CString strFontSize;
	m_cmbFontSize.GetLBText(m_cmbFontSize.GetCurSel(),strFontSize);
	m_htmlEditor.SetFontSize(_ttoi(strFontSize));

}

void CHtmlEditorDlg::OnBnClickedFontColorButton()
{
	CColorDialog dlg;
	dlg.m_cc.Flags |= CC_ENABLEHOOK;
	dlg.m_cc.lpfnHook = CFontHook;

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&dlg);
    int nRet = dlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&dlg);

	if(nRet==IDOK)
	{
		CString strColor;
		COLORREF cr = dlg.GetColor();
		strColor.Format(_T("%.2x%.2x%.2x"),GetRValue(cr),GetGValue(cr),GetBValue(cr));
		m_htmlEditor.SetForeColor(strColor);
	}
}

void CHtmlEditorDlg::InitFontSize()
{
	for (int i=1; i< 8; i++)
	{
		CString strFontSize;
		strFontSize.Format(L"%d",i);
		m_cmbFontSize.AddString(strFontSize);
	}
	m_cmbFontSize.SetCurSel(1);
}

void CHtmlEditorDlg::OnBnClickedItalicButton()
{
	m_htmlEditor.Italic();
}
